commit e33d3026dd0ff1322fcaa50e128d84199deaa61a
Author: Julien Enselme <julien.enselme@centrale-marseille.fr>
Date:   Sun Jul 27 17:31:25 2014 +0200

    Update drupal to 7.30

diff --git a/drupal7/includes/bootstrap.inc b/drupal7/includes/bootstrap.inc
index d8120cba..b61c9ddf 100644
--- a/drupal7/includes/bootstrap.inc
+++ b/drupal7/includes/bootstrap.inc
@@ -8,7 +8,7 @@
 /**
  * The current system version.
  */
-define('VERSION', '7.29');
+define('VERSION', '7.30');
 
 /**
  * Core API compatibility.
diff --git a/drupal7/includes/database/database.inc b/drupal7/includes/database/database.inc
index ad78ac0b..f78098bc 100644
--- a/drupal7/includes/database/database.inc
+++ b/drupal7/includes/database/database.inc
@@ -2832,7 +2832,7 @@ function db_drop_table($table) {
  *   will be set to the value of the key in all rows. This is most useful for
  *   creating NOT NULL columns with no default value in existing tables.
  * @param $keys_new
- *   Optional keys and indexes specification to be created on the table along
+ *   (optional) Keys and indexes specification to be created on the table along
  *   with adding the field. The format is the same as a table specification, but
  *   without the 'fields' element. If you are adding a type 'serial' field, you
  *   MUST specify at least one key or index including it in this array. See
@@ -3012,7 +3012,7 @@ function db_drop_index($table, $name) {
  * @param $spec
  *   The field specification for the new field.
  * @param $keys_new
- *   Optional keys and indexes specification to be created on the table along
+ *   (optional) Keys and indexes specification to be created on the table along
  *   with changing the field. The format is the same as a table specification
  *   but without the 'fields' element.
  */
diff --git a/drupal7/includes/database/schema.inc b/drupal7/includes/database/schema.inc
index d3943b29..68843a49 100644
--- a/drupal7/includes/database/schema.inc
+++ b/drupal7/includes/database/schema.inc
@@ -416,7 +416,7 @@ abstract class DatabaseSchema implements QueryPlaceholderInterface {
    *   This is most useful for creating NOT NULL columns with no default
    *   value in existing tables.
    * @param $keys_new
-   *   Optional keys and indexes specification to be created on the
+   *   (optional) Keys and indexes specification to be created on the
    *   table along with adding the field. The format is the same as a
    *   table specification but without the 'fields' element. If you are
    *   adding a type 'serial' field, you MUST specify at least one key
@@ -630,7 +630,7 @@ abstract class DatabaseSchema implements QueryPlaceholderInterface {
    * @param $spec
    *   The field specification for the new field.
    * @param $keys_new
-   *   Optional keys and indexes specification to be created on the
+   *   (optional) Keys and indexes specification to be created on the
    *   table along with changing the field. The format is the same as a
    *   table specification but without the 'fields' element.
    *
diff --git a/drupal7/includes/entity.inc b/drupal7/includes/entity.inc
index dc43e730..203ed87f 100644
--- a/drupal7/includes/entity.inc
+++ b/drupal7/includes/entity.inc
@@ -46,7 +46,7 @@ interface DrupalEntityControllerInterface {
 class DrupalDefaultEntityController implements DrupalEntityControllerInterface {
 
   /**
-   * Static cache of entities.
+   * Static cache of entities, keyed by entity ID.
    *
    * @var array
    */
diff --git a/drupal7/includes/xmlrpcs.inc b/drupal7/includes/xmlrpcs.inc
index 118f652d..8655c05b 100644
--- a/drupal7/includes/xmlrpcs.inc
+++ b/drupal7/includes/xmlrpcs.inc
@@ -9,7 +9,9 @@
  * Invokes XML-RPC methods on this server.
  *
  * @param array $callbacks
- *   Array of external XML-RPC method names with the callbacks they map to.
+ *   Either an associative array of external XML-RPC method names as keys with
+ *   the callbacks they map to as values, or a more complex structure
+ *   describing XML-RPC callbacks as returned from hook_xmlrpc().
  */
 function xmlrpc_server($callbacks) {
   $xmlrpc_server = new stdClass();
diff --git a/drupal7/modules/aggregator/aggregator.info b/drupal7/modules/aggregator/aggregator.info
index 72a27f9a..9d44d105 100644
--- a/drupal7/modules/aggregator/aggregator.info
+++ b/drupal7/modules/aggregator/aggregator.info
@@ -7,8 +7,8 @@ files[] = aggregator.test
 configure = admin/config/services/aggregator/settings
 stylesheets[all][] = aggregator.css
 
-; Information added by Drupal.org packaging script on 2014-07-16
-version = "7.29"
+; Information added by Drupal.org packaging script on 2014-07-24
+version = "7.30"
 project = "drupal"
-datestamp = "1405543132"
+datestamp = "1406239730"
 
diff --git a/drupal7/modules/aggregator/tests/aggregator_test.info b/drupal7/modules/aggregator/tests/aggregator_test.info
index 645aebae..b8486fce 100644
--- a/drupal7/modules/aggregator/tests/aggregator_test.info
+++ b/drupal7/modules/aggregator/tests/aggregator_test.info
@@ -5,8 +5,8 @@ version = VERSION
 core = 7.x
 hidden = TRUE
 
-; Information added by Drupal.org packaging script on 2014-07-16
-version = "7.29"
+; Information added by Drupal.org packaging script on 2014-07-24
+version = "7.30"
 project = "drupal"
-datestamp = "1405543132"
+datestamp = "1406239730"
 
diff --git a/drupal7/modules/block/block.info b/drupal7/modules/block/block.info
index 2ff09dd8..70fa5bba 100644
--- a/drupal7/modules/block/block.info
+++ b/drupal7/modules/block/block.info
@@ -6,8 +6,8 @@ core = 7.x
 files[] = block.test
 configure = admin/structure/block
 
-; Information added by Drupal.org packaging script on 2014-07-16
-version = "7.29"
+; Information added by Drupal.org packaging script on 2014-07-24
+version = "7.30"
 project = "drupal"
-datestamp = "1405543132"
+datestamp = "1406239730"
 
diff --git a/drupal7/modules/block/tests/block_test.info b/drupal7/modules/block/tests/block_test.info
index 1a6f817b..2dae1e53 100644
--- a/drupal7/modules/block/tests/block_test.info
+++ b/drupal7/modules/block/tests/block_test.info
@@ -5,8 +5,8 @@ version = VERSION
 core = 7.x
 hidden = TRUE
 
-; Information added by Drupal.org packaging script on 2014-07-16
-version = "7.29"
+; Information added by Drupal.org packaging script on 2014-07-24
+version = "7.30"
 project = "drupal"
-datestamp = "1405543132"
+datestamp = "1406239730"
 
diff --git a/drupal7/modules/block/tests/themes/block_test_theme/block_test_theme.info b/drupal7/modules/block/tests/themes/block_test_theme/block_test_theme.info
index 6a0052e0..16ad5ad8 100644
--- a/drupal7/modules/block/tests/themes/block_test_theme/block_test_theme.info
+++ b/drupal7/modules/block/tests/themes/block_test_theme/block_test_theme.info
@@ -13,8 +13,8 @@ regions[footer] = Footer
 regions[highlighted] = Highlighted
 regions[help] = Help
 
-; Information added by Drupal.org packaging script on 2014-07-16
-version = "7.29"
+; Information added by Drupal.org packaging script on 2014-07-24
+version = "7.30"
 project = "drupal"
-datestamp = "1405543132"
+datestamp = "1406239730"
 
diff --git a/drupal7/modules/blog/blog.info b/drupal7/modules/blog/blog.info
index 193d79bc..2ce39934 100644
--- a/drupal7/modules/blog/blog.info
+++ b/drupal7/modules/blog/blog.info
@@ -5,8 +5,8 @@ version = VERSION
 core = 7.x
 files[] = blog.test
 
-; Information added by Drupal.org packaging script on 2014-07-16
-version = "7.29"
+; Information added by Drupal.org packaging script on 2014-07-24
+version = "7.30"
 project = "drupal"
-datestamp = "1405543132"
+datestamp = "1406239730"
 
diff --git a/drupal7/modules/book/book.info b/drupal7/modules/book/book.info
index e4501cbf..ee7dbdf0 100644
--- a/drupal7/modules/book/book.info
+++ b/drupal7/modules/book/book.info
@@ -7,8 +7,8 @@ files[] = book.test
 configure = admin/content/book/settings
 stylesheets[all][] = book.css
 
-; Information added by Drupal.org packaging script on 2014-07-16
-version = "7.29"
+; Information added by Drupal.org packaging script on 2014-07-24
+version = "7.30"
 project = "drupal"
-datestamp = "1405543132"
+datestamp = "1406239730"
 
diff --git a/drupal7/modules/color/color.info b/drupal7/modules/color/color.info
index 2bf85b5c..6cf119e1 100644
--- a/drupal7/modules/color/color.info
+++ b/drupal7/modules/color/color.info
@@ -5,8 +5,8 @@ version = VERSION
 core = 7.x
 files[] = color.test
 
-; Information added by Drupal.org packaging script on 2014-07-16
-version = "7.29"
+; Information added by Drupal.org packaging script on 2014-07-24
+version = "7.30"
 project = "drupal"
-datestamp = "1405543132"
+datestamp = "1406239730"
 
diff --git a/drupal7/modules/comment/comment.info b/drupal7/modules/comment/comment.info
index 46bb174f..803054c8 100644
--- a/drupal7/modules/comment/comment.info
+++ b/drupal7/modules/comment/comment.info
@@ -9,8 +9,8 @@ files[] = comment.test
 configure = admin/content/comment
 stylesheets[all][] = comment.css
 
-; Information added by Drupal.org packaging script on 2014-07-16
-version = "7.29"
+; Information added by Drupal.org packaging script on 2014-07-24
+version = "7.30"
 project = "drupal"
-datestamp = "1405543132"
+datestamp = "1406239730"
 
diff --git a/drupal7/modules/contact/contact.info b/drupal7/modules/contact/contact.info
index 7e07c2dc..a9a02b49 100644
--- a/drupal7/modules/contact/contact.info
+++ b/drupal7/modules/contact/contact.info
@@ -6,8 +6,8 @@ core = 7.x
 files[] = contact.test
 configure = admin/structure/contact
 
-; Information added by Drupal.org packaging script on 2014-07-16
-version = "7.29"
+; Information added by Drupal.org packaging script on 2014-07-24
+version = "7.30"
 project = "drupal"
-datestamp = "1405543132"
+datestamp = "1406239730"
 
diff --git a/drupal7/modules/contextual/contextual.info b/drupal7/modules/contextual/contextual.info
index c3ad394e..df245b76 100644
--- a/drupal7/modules/contextual/contextual.info
+++ b/drupal7/modules/contextual/contextual.info
@@ -5,8 +5,8 @@ version = VERSION
 core = 7.x
 files[] = contextual.test
 
-; Information added by Drupal.org packaging script on 2014-07-16
-version = "7.29"
+; Information added by Drupal.org packaging script on 2014-07-24
+version = "7.30"
 project = "drupal"
-datestamp = "1405543132"
+datestamp = "1406239730"
 
diff --git a/drupal7/modules/dashboard/dashboard.info b/drupal7/modules/dashboard/dashboard.info
index 71c6c9f8..9f975b9c 100644
--- a/drupal7/modules/dashboard/dashboard.info
+++ b/drupal7/modules/dashboard/dashboard.info
@@ -7,8 +7,8 @@ files[] = dashboard.test
 dependencies[] = block
 configure = admin/dashboard/customize
 
-; Information added by Drupal.org packaging script on 2014-07-16
-version = "7.29"
+; Information added by Drupal.org packaging script on 2014-07-24
+version = "7.30"
 project = "drupal"
-datestamp = "1405543132"
+datestamp = "1406239730"
 
diff --git a/drupal7/modules/dblog/dblog.info b/drupal7/modules/dblog/dblog.info
index f799e170..130e8370 100644
--- a/drupal7/modules/dblog/dblog.info
+++ b/drupal7/modules/dblog/dblog.info
@@ -5,8 +5,8 @@ version = VERSION
 core = 7.x
 files[] = dblog.test
 
-; Information added by Drupal.org packaging script on 2014-07-16
-version = "7.29"
+; Information added by Drupal.org packaging script on 2014-07-24
+version = "7.30"
 project = "drupal"
-datestamp = "1405543132"
+datestamp = "1406239730"
 
diff --git a/drupal7/modules/field/field.crud.inc b/drupal7/modules/field/field.crud.inc
index 83863d6e..e4486d03 100644
--- a/drupal7/modules/field/field.crud.inc
+++ b/drupal7/modules/field/field.crud.inc
@@ -540,9 +540,9 @@ function field_create_instance($instance) {
  *   // Fetch an instance info array.
  *   $instance_info = field_info_instance($entity_type, $field_name, $bundle_name);
  *   // Change a single property in the instance definition.
- *   $instance_info['definition']['required'] = TRUE;
+ *   $instance_info['required'] = TRUE;
  *   // Write the changed definition back.
- *   field_update_instance($instance_info['definition']);
+ *   field_update_instance($instance_info);
  *   @endcode
  *
  * @throws FieldException
diff --git a/drupal7/modules/field/field.info b/drupal7/modules/field/field.info
index 232739bb..a542b69a 100644
--- a/drupal7/modules/field/field.info
+++ b/drupal7/modules/field/field.info
@@ -11,8 +11,8 @@ dependencies[] = field_sql_storage
 required = TRUE
 stylesheets[all][] = theme/field.css
 
-; Information added by Drupal.org packaging script on 2014-07-16
-version = "7.29"
+; Information added by Drupal.org packaging script on 2014-07-24
+version = "7.30"
 project = "drupal"
-datestamp = "1405543132"
+datestamp = "1406239730"
 
diff --git a/drupal7/modules/field/field.module b/drupal7/modules/field/field.module
index 52faf354..132238ec 100644
--- a/drupal7/modules/field/field.module
+++ b/drupal7/modules/field/field.module
@@ -961,6 +961,13 @@ function field_has_data($field) {
 /**
  * Determine whether the user has access to a given field.
  *
+ * This function does not determine whether access is granted to the entity
+ * itself, only the specific field. Callers are responsible for ensuring that
+ * entity access is also respected. For example, when checking field access for
+ * nodes, check node_access() before checking field_access(), and when checking
+ * field access for entities using the Entity API contributed module,
+ * check entity_access() before checking field_access().
+ *
  * @param $op
  *   The operation to be performed. Possible values:
  *   - 'edit'
diff --git a/drupal7/modules/field/modules/field_sql_storage/field_sql_storage.info b/drupal7/modules/field/modules/field_sql_storage/field_sql_storage.info
index 72134db2..9f967ce1 100644
--- a/drupal7/modules/field/modules/field_sql_storage/field_sql_storage.info
+++ b/drupal7/modules/field/modules/field_sql_storage/field_sql_storage.info
@@ -7,8 +7,8 @@ dependencies[] = field
 files[] = field_sql_storage.test
 required = TRUE
 
-; Information added by Drupal.org packaging script on 2014-07-16
-version = "7.29"
+; Information added by Drupal.org packaging script on 2014-07-24
+version = "7.30"
 project = "drupal"
-datestamp = "1405543132"
+datestamp = "1406239730"
 
diff --git a/drupal7/modules/field/modules/list/list.info b/drupal7/modules/field/modules/list/list.info
index d75b05b4..b2451a99 100644
--- a/drupal7/modules/field/modules/list/list.info
+++ b/drupal7/modules/field/modules/list/list.info
@@ -7,8 +7,8 @@ dependencies[] = field
 dependencies[] = options
 files[] = tests/list.test
 
-; Information added by Drupal.org packaging script on 2014-07-16
-version = "7.29"
+; Information added by Drupal.org packaging script on 2014-07-24
+version = "7.30"
 project = "drupal"
-datestamp = "1405543132"
+datestamp = "1406239730"
 
diff --git a/drupal7/modules/field/modules/list/tests/list_test.info b/drupal7/modules/field/modules/list/tests/list_test.info
index 3cc0f138..28f12e7b 100644
--- a/drupal7/modules/field/modules/list/tests/list_test.info
+++ b/drupal7/modules/field/modules/list/tests/list_test.info
@@ -5,8 +5,8 @@ package = Testing
 version = VERSION
 hidden = TRUE
 
-; Information added by Drupal.org packaging script on 2014-07-16
-version = "7.29"
+; Information added by Drupal.org packaging script on 2014-07-24
+version = "7.30"
 project = "drupal"
-datestamp = "1405543132"
+datestamp = "1406239730"
 
diff --git a/drupal7/modules/field/modules/number/number.info b/drupal7/modules/field/modules/number/number.info
index ee15dcd4..1f9bb7dc 100644
--- a/drupal7/modules/field/modules/number/number.info
+++ b/drupal7/modules/field/modules/number/number.info
@@ -6,8 +6,8 @@ core = 7.x
 dependencies[] = field
 files[] = number.test
 
-; Information added by Drupal.org packaging script on 2014-07-16
-version = "7.29"
+; Information added by Drupal.org packaging script on 2014-07-24
+version = "7.30"
 project = "drupal"
-datestamp = "1405543132"
+datestamp = "1406239730"
 
diff --git a/drupal7/modules/field/modules/options/options.info b/drupal7/modules/field/modules/options/options.info
index c9d9ba93..e9acaa03 100644
--- a/drupal7/modules/field/modules/options/options.info
+++ b/drupal7/modules/field/modules/options/options.info
@@ -6,8 +6,8 @@ core = 7.x
 dependencies[] = field
 files[] = options.test
 
-; Information added by Drupal.org packaging script on 2014-07-16
-version = "7.29"
+; Information added by Drupal.org packaging script on 2014-07-24
+version = "7.30"
 project = "drupal"
-datestamp = "1405543132"
+datestamp = "1406239730"
 
diff --git a/drupal7/modules/field/modules/text/text.info b/drupal7/modules/field/modules/text/text.info
index dc82b524..026ce62a 100644
--- a/drupal7/modules/field/modules/text/text.info
+++ b/drupal7/modules/field/modules/text/text.info
@@ -7,8 +7,8 @@ dependencies[] = field
 files[] = text.test
 required = TRUE
 
-; Information added by Drupal.org packaging script on 2014-07-16
-version = "7.29"
+; Information added by Drupal.org packaging script on 2014-07-24
+version = "7.30"
 project = "drupal"
-datestamp = "1405543132"
+datestamp = "1406239730"
 
diff --git a/drupal7/modules/field/tests/field_test.info b/drupal7/modules/field/tests/field_test.info
index 790fb3ee..b737b709 100644
--- a/drupal7/modules/field/tests/field_test.info
+++ b/drupal7/modules/field/tests/field_test.info
@@ -6,8 +6,8 @@ files[] = field_test.entity.inc
 version = VERSION
 hidden = TRUE
 
-; Information added by Drupal.org packaging script on 2014-07-16
-version = "7.29"
+; Information added by Drupal.org packaging script on 2014-07-24
+version = "7.30"
 project = "drupal"
-datestamp = "1405543132"
+datestamp = "1406239730"
 
diff --git a/drupal7/modules/field_ui/field_ui.api.php b/drupal7/modules/field_ui/field_ui.api.php
index 05d9f053..9b80077c 100644
--- a/drupal7/modules/field_ui/field_ui.api.php
+++ b/drupal7/modules/field_ui/field_ui.api.php
@@ -134,6 +134,9 @@ function hook_field_widget_settings_form($field, $instance) {
 /**
  * Specify the form elements for a formatter's settings.
  *
+ * This hook is only invoked if hook_field_formatter_settings_summary()
+ * returns a non-empty value.
+ *
  * @param $field
  *   The field structure being configured.
  * @param $instance
diff --git a/drupal7/modules/field_ui/field_ui.info b/drupal7/modules/field_ui/field_ui.info
index bc179676..c1a1c9e0 100644
--- a/drupal7/modules/field_ui/field_ui.info
+++ b/drupal7/modules/field_ui/field_ui.info
@@ -6,8 +6,8 @@ core = 7.x
 dependencies[] = field
 files[] = field_ui.test
 
-; Information added by Drupal.org packaging script on 2014-07-16
-version = "7.29"
+; Information added by Drupal.org packaging script on 2014-07-24
+version = "7.30"
 project = "drupal"
-datestamp = "1405543132"
+datestamp = "1406239730"
 
diff --git a/drupal7/modules/file/file.info b/drupal7/modules/file/file.info
index ac49c547..826ec37b 100644
--- a/drupal7/modules/file/file.info
+++ b/drupal7/modules/file/file.info
@@ -6,8 +6,8 @@ core = 7.x
 dependencies[] = field
 files[] = tests/file.test
 
-; Information added by Drupal.org packaging script on 2014-07-16
-version = "7.29"
+; Information added by Drupal.org packaging script on 2014-07-24
+version = "7.30"
 project = "drupal"
-datestamp = "1405543132"
+datestamp = "1406239730"
 
diff --git a/drupal7/modules/file/file.module b/drupal7/modules/file/file.module
index ed165368..a4a7f03d 100644
--- a/drupal7/modules/file/file.module
+++ b/drupal7/modules/file/file.module
@@ -478,6 +478,7 @@ function file_managed_file_process($element, &$form_state, $form) {
  */
 function file_managed_file_value(&$element, $input = FALSE, $form_state = NULL) {
   $fid = 0;
+  $force_default = FALSE;
 
   // Find the current value of this field from the form state.
   $form_state_fid = $form_state['values'];
@@ -510,16 +511,25 @@ function file_managed_file_value(&$element, $input = FALSE, $form_state = NULL)
           $callback($element, $input, $form_state);
         }
       }
-      // Load file and check access if the FID has changed, to confirm it
-      // exists and that the current user has access to it.
-      if (isset($input['fid']) && ($file = file_load($input['fid'])) && file_download_access($file->uri)) {
-        $fid = $file->fid;
+      // If a FID was submitted, load the file (and check access if it's not a
+      // public file) to confirm it exists and that the current user has access
+      // to it.
+      if (isset($input['fid']) && ($file = file_load($input['fid']))) {
+        if (file_uri_scheme($file->uri) == 'public' || file_download_access($file->uri)) {
+          $fid = $file->fid;
+        }
+        // If the current user doesn't have access, don't let the file be
+        // changed.
+        else {
+          $force_default = TRUE;
+        }
       }
     }
   }
 
-  // If there is no input, set the default value.
-  else {
+  // If there is no input or if the default value was requested above, use the
+  // default value.
+  if ($input === FALSE || $force_default) {
     if ($element['#extended']) {
       $default_fid = isset($element['#default_value']['fid']) ? $element['#default_value']['fid'] : 0;
       $return = isset($element['#default_value']) ? $element['#default_value'] : array('fid' => 0);
diff --git a/drupal7/modules/file/tests/file.test b/drupal7/modules/file/tests/file.test
index 4d53d747..0f6a578d 100644
--- a/drupal7/modules/file/tests/file.test
+++ b/drupal7/modules/file/tests/file.test
@@ -220,6 +220,128 @@ class FileFieldTestCase extends DrupalWebTestCase {
   }
 }
 
+/**
+ * Tests adding a file to a non-node entity.
+ */
+class FileTaxonomyTermTestCase extends DrupalWebTestCase {
+  protected $admin_user;
+
+  public static function getInfo() {
+    return array(
+      'name' => 'Taxonomy term file test',
+      'description' => 'Tests adding a file to a non-node entity.',
+      'group' => 'File',
+    );
+  }
+
+  public function setUp() {
+    $modules[] = 'file';
+    $modules[] = 'taxonomy';
+    parent::setUp($modules);
+    $this->admin_user = $this->drupalCreateUser(array('access content', 'access administration pages', 'administer site configuration', 'administer taxonomy'));
+    $this->drupalLogin($this->admin_user);
+  }
+
+  /**
+   * Creates a file field and attaches it to the "Tags" taxonomy vocabulary.
+   *
+   * @param $name
+   *   The field name of the file field to create.
+   * @param $uri_scheme
+   *   The URI scheme to use for the file field (for example, "private" to
+   *   create a field that stores private files or "public" to create a field
+   *   that stores public files).
+   */
+  protected function createAttachFileField($name, $uri_scheme) {
+    $field = array(
+      'field_name' => $name,
+      'type' => 'file',
+      'settings' => array(
+        'uri_scheme' => $uri_scheme,
+      ),
+      'cardinality' => 1,
+    );
+    field_create_field($field);
+    // Attach an instance of it.
+    $instance = array(
+      'field_name' => $name,
+      'label' => 'File',
+      'entity_type' => 'taxonomy_term',
+      'bundle' => 'tags',
+      'required' => FALSE,
+      'settings' => array(),
+      'widget' => array(
+        'type' => 'file_generic',
+        'settings' => array(),
+      ),
+    );
+    field_create_instance($instance);
+  }
+
+  /**
+   * Tests that a public file can be attached to a taxonomy term.
+   *
+   * This is a regression test for https://www.drupal.org/node/2305017.
+   */
+  public function testTermFilePublic() {
+    $this->_testTermFile('public');
+  }
+
+  /**
+   * Tests that a private file can be attached to a taxonomy term.
+   *
+   * This is a regression test for https://www.drupal.org/node/2305017.
+   */
+  public function testTermFilePrivate() {
+    $this->_testTermFile('private');
+  }
+
+  /**
+   * Runs tests for attaching a file field to a taxonomy term.
+   *
+   * @param $uri_scheme
+   *   The URI scheme to use for the file field, either "public" or "private".
+   */
+  protected function _testTermFile($uri_scheme) {
+    $field_name = strtolower($this->randomName());
+    $this->createAttachFileField($field_name, $uri_scheme);
+    // Get a file to upload.
+    $file = current($this->drupalGetTestFiles('text'));
+    // Add a filesize property to files as would be read by file_load().
+    $file->filesize = filesize($file->uri);
+    $langcode = LANGUAGE_NONE;
+    $edit = array(
+      "name" => $this->randomName(),
+    );
+    // Attach a file to the term.
+    $edit['files[' . $field_name . '_' . $langcode . '_0]'] = drupal_realpath($file->uri);
+    $this->drupalPost("admin/structure/taxonomy/tags/add", $edit, t('Save'));
+    // Find the term ID we just created.
+    $tid = db_query_range('SELECT tid FROM {taxonomy_term_data} ORDER BY tid DESC', 0, 1)->fetchField();
+    $terms = entity_load('taxonomy_term', array($tid));
+    $term = $terms[$tid];
+    $fid = $term->{$field_name}[LANGUAGE_NONE][0]['fid'];
+    // Check that the uploaded file is present on the edit form.
+    $this->drupalGet("taxonomy/term/$tid/edit");
+    $file_input_name = $field_name . '[' . LANGUAGE_NONE . '][0][fid]';
+    $this->assertFieldByXpath('//input[@type="hidden" and @name="' . $file_input_name . '"]', $fid, 'File is attached on edit form.');
+    // Edit the term and change name without changing the file.
+    $edit = array(
+      "name" => $this->randomName(),
+    );
+    $this->drupalPost("taxonomy/term/$tid/edit", $edit, t('Save'));
+    // Check that the uploaded file is still present on the edit form.
+    $this->drupalGet("taxonomy/term/$tid/edit");
+    $file_input_name = $field_name . '[' . LANGUAGE_NONE . '][0][fid]';
+    $this->assertFieldByXpath('//input[@type="hidden" and @name="' . $file_input_name . '"]', $fid, 'File is attached on edit form.');
+    // Load term while resetting the cache.
+    $terms = entity_load('taxonomy_term', array($tid), array(), TRUE);
+    $term = $terms[$tid];
+    $this->assertTrue(!empty($term->{$field_name}[LANGUAGE_NONE]), 'Term has attached files.');
+    $this->assertEqual($term->{$field_name}[LANGUAGE_NONE][0]['fid'], $fid, 'Same File ID is attached to the term.');
+  }
+}
+
 /**
  * Tests the 'managed_file' element type.
  *
diff --git a/drupal7/modules/file/tests/file_module_test.info b/drupal7/modules/file/tests/file_module_test.info
index 15f0a043..f5007a72 100644
--- a/drupal7/modules/file/tests/file_module_test.info
+++ b/drupal7/modules/file/tests/file_module_test.info
@@ -5,8 +5,8 @@ version = VERSION
 core = 7.x
 hidden = TRUE
 
-; Information added by Drupal.org packaging script on 2014-07-16
-version = "7.29"
+; Information added by Drupal.org packaging script on 2014-07-24
+version = "7.30"
 project = "drupal"
-datestamp = "1405543132"
+datestamp = "1406239730"
 
diff --git a/drupal7/modules/filter/filter.info b/drupal7/modules/filter/filter.info
index f4c9c23f..d8fa753e 100644
--- a/drupal7/modules/filter/filter.info
+++ b/drupal7/modules/filter/filter.info
@@ -7,8 +7,8 @@ files[] = filter.test
 required = TRUE
 configure = admin/config/content/formats
 
-; Information added by Drupal.org packaging script on 2014-07-16
-version = "7.29"
+; Information added by Drupal.org packaging script on 2014-07-24
+version = "7.30"
 project = "drupal"
-datestamp = "1405543132"
+datestamp = "1406239730"
 
diff --git a/drupal7/modules/forum/forum.info b/drupal7/modules/forum/forum.info
index 744c6470..707a8a81 100644
--- a/drupal7/modules/forum/forum.info
+++ b/drupal7/modules/forum/forum.info
@@ -9,8 +9,8 @@ files[] = forum.test
 configure = admin/structure/forum
 stylesheets[all][] = forum.css
 
-; Information added by Drupal.org packaging script on 2014-07-16
-version = "7.29"
+; Information added by Drupal.org packaging script on 2014-07-24
+version = "7.30"
 project = "drupal"
-datestamp = "1405543132"
+datestamp = "1406239730"
 
diff --git a/drupal7/modules/help/help.info b/drupal7/modules/help/help.info
index 0e24f89a..5d631a2b 100644
--- a/drupal7/modules/help/help.info
+++ b/drupal7/modules/help/help.info
@@ -5,8 +5,8 @@ version = VERSION
 core = 7.x
 files[] = help.test
 
-; Information added by Drupal.org packaging script on 2014-07-16
-version = "7.29"
+; Information added by Drupal.org packaging script on 2014-07-24
+version = "7.30"
 project = "drupal"
-datestamp = "1405543132"
+datestamp = "1406239730"
 
diff --git a/drupal7/modules/image/image.info b/drupal7/modules/image/image.info
index a1544c35..8e0a2c36 100644
--- a/drupal7/modules/image/image.info
+++ b/drupal7/modules/image/image.info
@@ -7,8 +7,8 @@ dependencies[] = file
 files[] = image.test
 configure = admin/config/media/image-styles
 
-; Information added by Drupal.org packaging script on 2014-07-16
-version = "7.29"
+; Information added by Drupal.org packaging script on 2014-07-24
+version = "7.30"
 project = "drupal"
-datestamp = "1405543132"
+datestamp = "1406239730"
 
diff --git a/drupal7/modules/image/tests/image_module_test.info b/drupal7/modules/image/tests/image_module_test.info
index 43840d79..80d914b9 100644
--- a/drupal7/modules/image/tests/image_module_test.info
+++ b/drupal7/modules/image/tests/image_module_test.info
@@ -6,8 +6,8 @@ core = 7.x
 files[] = image_module_test.module
 hidden = TRUE
 
-; Information added by Drupal.org packaging script on 2014-07-16
-version = "7.29"
+; Information added by Drupal.org packaging script on 2014-07-24
+version = "7.30"
 project = "drupal"
-datestamp = "1405543132"
+datestamp = "1406239730"
 
diff --git a/drupal7/modules/locale/locale.info b/drupal7/modules/locale/locale.info
index 6182cd9e..bddc8bc7 100644
--- a/drupal7/modules/locale/locale.info
+++ b/drupal7/modules/locale/locale.info
@@ -6,8 +6,8 @@ core = 7.x
 files[] = locale.test
 configure = admin/config/regional/language
 
-; Information added by Drupal.org packaging script on 2014-07-16
-version = "7.29"
+; Information added by Drupal.org packaging script on 2014-07-24
+version = "7.30"
 project = "drupal"
-datestamp = "1405543132"
+datestamp = "1406239730"
 
diff --git a/drupal7/modules/locale/tests/locale_test.info b/drupal7/modules/locale/tests/locale_test.info
index 5a6e122c..5cc8fff8 100644
--- a/drupal7/modules/locale/tests/locale_test.info
+++ b/drupal7/modules/locale/tests/locale_test.info
@@ -5,8 +5,8 @@ package = Testing
 version = VERSION
 hidden = TRUE
 
-; Information added by Drupal.org packaging script on 2014-07-16
-version = "7.29"
+; Information added by Drupal.org packaging script on 2014-07-24
+version = "7.30"
 project = "drupal"
-datestamp = "1405543132"
+datestamp = "1406239730"
 
diff --git a/drupal7/modules/menu/menu.info b/drupal7/modules/menu/menu.info
index f58059f3..b8c9762e 100644
--- a/drupal7/modules/menu/menu.info
+++ b/drupal7/modules/menu/menu.info
@@ -6,8 +6,8 @@ core = 7.x
 files[] = menu.test
 configure = admin/structure/menu
 
-; Information added by Drupal.org packaging script on 2014-07-16
-version = "7.29"
+; Information added by Drupal.org packaging script on 2014-07-24
+version = "7.30"
 project = "drupal"
-datestamp = "1405543132"
+datestamp = "1406239730"
 
diff --git a/drupal7/modules/node/node.info b/drupal7/modules/node/node.info
index 21f4db10..adb87bf3 100644
--- a/drupal7/modules/node/node.info
+++ b/drupal7/modules/node/node.info
@@ -9,8 +9,8 @@ required = TRUE
 configure = admin/structure/types
 stylesheets[all][] = node.css
 
-; Information added by Drupal.org packaging script on 2014-07-16
-version = "7.29"
+; Information added by Drupal.org packaging script on 2014-07-24
+version = "7.30"
 project = "drupal"
-datestamp = "1405543132"
+datestamp = "1406239730"
 
